jjb: Use the https protocol for checkouts on Github, it's faster
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
5a196804 1#!/bin/bash -exu
f3d8604b 2#
1d5a0a3c 3# Copyright (C) 2016-2019 - Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
39961776
MJ
18# Parameters
19arch=${arch:-}
20cross_arch=${cross_arch:-}
21ktag=${ktag:-}
5a196804
MJ
22kgitrepo=${kgitrepo:-}
23mversion=${mversion:-}
24mgitrepo=${mgitrepo:-}
39961776
MJ
25
26
339db64d
MJ
27## FUNCTIONS ##
28
f3d8604b
MJ
29# Kernel version compare functions
30verlte() {
51fa2ab3 31 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
32}
33
34verlt() {
28b10e79 35 # shellcheck disable=SC2015
51fa2ab3 36 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
37}
38
39vergte() {
51fa2ab3 40 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
41}
42
43vergt() {
28b10e79 44 # shellcheck disable=SC2015
51fa2ab3 45 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
46}
47
339db64d 48
5a196804
MJ
49git_clone_modules_sources() {
50 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
51
52 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
53 # as a branch name.
54 if [ "${mversion:0:5}" = "refs/" ]; then
55 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
56 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
57 else
58 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
59 fi
5a196804
MJ
60}
61
62# Checkout a shallow kernel tree of the specified tag
63git_clone_linux_sources() {
64 mkdir -p "$LINUX_GIT_DIR"
65 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
66}
7e02032c 67
7e02032c 68
5a196804
MJ
69# Export the kernel sources from the git repo
70git_export_linux_sources() {
71 cd "$LINUX_GIT_DIR"
72 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
73}
74
75
76# Upload the tar archive to the object store
77upload_archive_obj() {
78 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
79 rm -f "$WORKSPACE/$obj_name"
80}
81
82
83extract_archive_obj() {
84 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
85 rm -f "$WORKSPACE/$obj_name"
86}
87
88
89tar_archive_obj() {
90 cd "$LINUX_OBJ_DIR"
91 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
92 cd -
93}
94
95# Find the most recent GCC version supported by the kernel sources
96select_compiler() {
97 local selected_cc
98
99 cd "$LINUX_SRCOBJ_DIR"
100
101 kversion=$(make -s kernelversion)
102
103 set +e
104
1d5a0a3c 105 for cc in gcc-5 gcc-4.8; do
5a196804
MJ
106 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
107 selected_cc="$cc"
108 break
109 fi
110 done
111
112 set -e
113
114 if [ "x$selected_cc" = "x" ]; then
115 echo "Found no suitable compiler."
116 exit 1
117 fi
118
1d5a0a3c
MJ
119 # Force gcc-4.8 for kernels before 3.18
120 if { verlt "$kversion" "3.18"; }; then
23db2292 121 selected_cc=gcc-4.8
7e02032c
MJ
122 fi
123
425e4992
MJ
124 if [ "$selected_cc" != "gcc-4.8" ]; then
125 # Older kernel Makefiles do not expect the compiler to default to PIE
126 KAFLAGS="-fno-pie"
c45b04df 127 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
128 KCPPFLAGS="-fno-pie"
129 export KAFLAGS KCFLAGS KCPPFLAGS
130 fi
131
5a196804 132 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 133 export HOSTCC="${selected_cc}"
5a196804
MJ
134
135 cd -
136}
137
138
139build_linux_kernel() {
140 cd "$LINUX_SRCOBJ_DIR"
141
142 kversion=$(make -s kernelversion)
143
7e02032c 144 # Generate kernel configuration
a1ae361e 145 case "$ktag" in
7e02032c 146 Ubuntu*)
39961776 147 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 148 if vergte "${kversion}" "4.10"; then
39961776
MJ
149 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
150 exit 0
151 fi
152 fi
af101606
MJ
153
154 # Disable riscv64 config generation, we don't have a toolchain on bionic
155 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
156
073dc82c
MJ
157 # Hack for kernel Ubuntu-hwe-5.8
158 if [ ! -f "debian/compat" ]; then
159 echo "10" > "debian/compat"
160 fi
161
a46abb0a
MJ
162 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
163 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 164 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 165 ;;
c45b04df 166
7e02032c 167 *)
16844a6d
MJ
168 # Force 32bit build on i386, default is 64bit
169 if [ "$arch" = "i386" ]; then
5a196804
MJ
170 export ARCH="i386"
171 fi
172
173 # allyesconfig is mostly broken for kernels of the 2.6 series
174 if verlt "$kversion" "3.0"; then
175 vanilla_config="defconfig"
7a76a4d0
MJ
176 fi
177
5a196804 178 make "${vanilla_config}"
7e02032c
MJ
179 ;;
180 esac
181
53b51a15 182 # oldnoconfig was renamed in 4.19
5a196804 183 if vergte "$kversion" "4.19"; then
53b51a15 184 update_conf_target="olddefconfig"
5a196804 185 else
53b51a15 186 update_conf_target="oldnoconfig"
5a196804
MJ
187 fi
188
189 # Fix 'defined(@array)' was removed from recent perl
190 if [ -f "kernel/timeconst.pl" ]; then
191 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
192 fi
193
194 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 195 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
196 if [ -f "arch/x86/kvm/svm.c" ]; then
197 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
198 fi
199
200 if [ -f "arch/x86/kvm/vmx.c" ]; then
201 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
202 fi
203 fi
204
53b51a15
MJ
205 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
206 # Convert them to 'cmpw' which was previously done silently
207 if verlt "$kversion" "4.9"; then
208 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
209 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
210 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
211 fi
212
5a196804
MJ
213 # Fix a typo in v2.6.36.x
214 if [ -f "arch/x86/kernel/entry_64.S" ]; then
215 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
216 fi
217
53b51a15
MJ
218 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
219 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
220 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
221 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
222 fi
223
5a196804
MJ
224 # Fix kernel < 3.0 with gcc >= 4.7
225 if verlt "$kversion" "3.0"; then
226 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
227 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
228 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
229 echo "header-y += linkage.h" >> include/linux/Kbuild
230 fi
231
7e02032c 232 # GCC 4.8
53b51a15
MJ
233 if [ "$HOSTCC" == "gcc-4.8" ]; then
234 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
235 fi
7e02032c
MJ
236
237 # Don't try to sign modules
53b51a15 238 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 239
9ef18fa2 240 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 241 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
242
243 # Cause problems with inline assembly on i386
53b51a15 244 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 245
1d5a0a3c 246 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
247 scripts/config --disable CONFIG_SAMPLES
248 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
249
250 # Disable kcov
53b51a15 251 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
252
253 # Broken on some RT kernels
53b51a15 254 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 255
1e300ea9 256 # Broken drivers
53b51a15
MJ
257 scripts/config --disable CONFIG_RAPIDIO_TSI721
258 scripts/config --disable CONFIG_SGI_XP
259 scripts/config --disable CONFIG_MFD_WM8994
260 scripts/config --disable CONFIG_DRM_RADEON
261 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 262
5a196804
MJ
263 # IGBVF won't build with recent gcc on 2.6.38.x
264 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 265 scripts/config --disable CONFIG_IGBVF
5a196804 266 fi
9ef18fa2 267
51fa2ab3 268 # Set required options
53b51a15
MJ
269 scripts/config --enable CONFIG_TRACEPOINTS
270 scripts/config --enable CONFIG_KALLSYMS
271 scripts/config --enable CONFIG_HIGH_RES_TIMERS
272 scripts/config --enable CONFIG_KPROBES
273 scripts/config --enable CONFIG_FTRACE
274 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
275 scripts/config --enable CONFIG_KALLSYMS_ALL
276 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
277 scripts/config --enable CONFIG_PERF_EVENTS
278 scripts/config --enable CONFIG_EVENT_TRACING
279 scripts/config --enable CONFIG_KRETPROBES
7e02032c 280
7a76a4d0 281 # Debug
5a196804
MJ
282 #cat .config
283
284 make "$update_conf_target" CC="$CC"
285 make -j"$NPROC" CC="$CC"
286
c45b04df 287 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
288
289 # Save the kernel and modules
290 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15 291 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
f4c112e8 292 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
293 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
294 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
295 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
296}
297
298
299extract_distro_headers() {
300
301 # Enter linux source dir
302 cd "${LINUX_SRCOBJ_DIR}"
303
304
305 # For RT kernels, copy version file
306 if [ -s localversion-rt ]; then
307 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
308 fi
309
310 # Copy all Makefile related stuff
311 find . -path './include/*' -prune \
312 -o -path './scripts/*' -prune -o -type f \
313 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
314 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
315 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
316
317 # Copy base scripts and include dirs
318 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 319
5a196804
MJ
320 # Copy arch includes
321 (find arch -name include -type d -print0 | \
322 xargs -0 -n1 -i: find : -type f) | \
323 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
324
325 # Copy arch scripts
326 (find arch -name scripts -type d -print0 | \
327 xargs -0 -n1 -i: find : -type f) | \
328 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
329
330 # Cleanup scripts
331 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
332 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
333
04873cc3 334 # On powerpc 32bits this object is required to link modules
5a196804 335 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
336 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
337 :
338 else
04873cc3
MJ
339 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
340 fi
5a196804
MJ
341 fi
342
343 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
344 if [ "${karch}" = "arm64" ]; then
345 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
346 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
347 fi
348 fi
349
350 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
351 if [ -f tools/objtool/objtool ]; then
352 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
353 fi
354
355 if [ -f "arch/x86/kernel/macros.s" ]; then
356 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
357 fi
358
359 # Copy modules related stuff, if available
360 if [ -s Module.symvers ]; then
361 cp Module.symvers "${LINUX_HDROBJ_DIR}"
362 fi
363
364 if [ -s System.map ]; then
365 cp System.map "${LINUX_HDROBJ_DIR}"
366 fi
367
368 if [ -s Module.markers ]; then
369 cp Module.markers "${LINUX_HDROBJ_DIR}"
370 fi
371
372 # Copy config file
373 cp .config "${LINUX_HDROBJ_DIR}"
374
375 # Make sure the Makefile and version.h have a matching timestamp so that
376 # external modules can be built
377 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
378 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
379 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
380 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
381 else
382 echo "Missing version.h"
383 exit 1
384 fi
385 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
386
387 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
388 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
389
390 # Finally clean the object files from the full source tree
391 make clean
392
393 # And regen the modules support files
394 make modules_prepare CC="$CC"
51fa2ab3 395
04873cc3 396 # On powerpc 32bits this object is required to link modules
d815b018 397 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
398 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
399 :
400 else
04873cc3
MJ
401 make arch/powerpc/lib/crtsavres.o CC="$CC"
402 fi
d815b018
MJ
403 fi
404
7a76a4d0 405 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 406 if [ "${karch}" = "arm64" ]; then
c236528e 407 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 408 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
409 fi
410 fi
411
7e02032c 412 # Version specific tasks
a1ae361e 413 case "$ktag" in
7e02032c
MJ
414 Ubuntu*)
415 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 416 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
417 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
418 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
419 ;;
420 esac
7e02032c
MJ
421}
422
423
339db64d
MJ
424build_modules() {
425
5a196804
MJ
426 local kdir="$1"
427 local outdir="$2"
428 local kversion
429
430 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 431
339db64d 432 # Enter lttng-modules source dir
5a196804 433 cd "${MODULES_GIT_DIR}"
339db64d
MJ
434
435 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
436 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
437 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
438 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
439
440 set +e
441
442 # Build modules
51fa2ab3 443 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 444 ret=$?
339db64d 445
5a196804
MJ
446 set -e
447
339db64d 448 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 449 if [ "$ret" -eq 0 ]; then
e9b44189 450 echo "This build should have failed."
339db64d
MJ
451 exit 1
452 fi
453
454 # We have to publish at least one file or the build will fail
5a196804 455 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 456
5a196804 457 KERNELDIR="${kdir}" make clean
7e02032c 458
339db64d
MJ
459 else # Regular build
460
461 # Build modules against full kernel sources
51fa2ab3 462 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
463
464 # Install modules to build dir
5a196804 465 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
466
467 # Clean build dir
5a196804 468 KERNELDIR="${kdir}" make clean
339db64d
MJ
469 fi
470}
471
472
473## MAIN ##
474
f3d8604b
MJ
475# Use all CPU cores
476NPROC=$(nproc)
477
5a196804
MJ
478MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
479LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 480
5a196804
MJ
481LINUX_OBJ_DIR="${WORKSPACE}/linux"
482LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
483LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
484LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 485
5a196804
MJ
486MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
487MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 488
5a196804
MJ
489LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
490
491OBJ_STORE_URL="s3://jenkins"
492
493cd "$WORKSPACE"
494
495# Create build directories
496mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
497
498git_clone_modules_sources
339db64d 499
7e02032c 500# Setup cross compile env if available
39961776 501if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
502
503 case "$cross_arch" in
504 "armhf")
505 karch="arm"
506 cross_compile="arm-linux-gnueabihf-"
53b51a15 507 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
508 ubuntu_config="armhf-config.flavour.generic"
509 ;;
510
511 "arm64")
512 karch="arm64"
513 cross_compile="aarch64-linux-gnu-"
53b51a15 514 vanilla_config="defconfig"
7e02032c
MJ
515 ubuntu_config="arm64-config.flavour.generic"
516 ;;
517
518 "powerpc")
519 karch="powerpc"
520 cross_compile="powerpc-linux-gnu-"
e9b44189 521 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
522 ubuntu_config="powerpc-config.flavour.powerpc-smp"
523 ;;
524
525 "ppc64el")
526 karch="powerpc"
527 cross_compile="powerpc64le-linux-gnu-"
e9b44189 528 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
529 ubuntu_config="ppc64el-config.flavour.generic"
530 ;;
531
532 *)
51fa2ab3 533 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
534 exit 1
535 ;;
536 esac
339db64d 537
7e02032c
MJ
538 # Export variables used by Kbuild for cross compilation
539 export ARCH="${karch}"
540 export CROSS_COMPILE="${cross_compile}"
339db64d 541
7e02032c 542# Set arch specific values if we are not cross compiling
39961776 543elif [ "x${arch}" != "x" ]; then
e9b44189 544
7e02032c 545 case "$arch" in
16844a6d 546 "i386")
7e02032c 547 karch="x86"
e9b44189 548 vanilla_config="allyesconfig"
7e02032c
MJ
549 ubuntu_config="i386-config.flavour.generic"
550 ;;
551
16844a6d 552 "amd64")
7e02032c 553 karch="x86"
e9b44189 554 vanilla_config="allyesconfig"
7e02032c
MJ
555 ubuntu_config="amd64-config.flavour.generic"
556 ;;
557
558 "armhf")
559 karch="arm"
e9b44189 560 vanilla_config="allyesconfig"
7e02032c
MJ
561 ubuntu_config="armhf-config.flavour.generic"
562 ;;
563
564 "arm64")
565 karch="arm64"
e9b44189 566 vanilla_config="allyesconfig"
7e02032c
MJ
567 ubuntu_config="arm64-config.flavour.generic"
568 ;;
569
570 "powerpc")
571 karch="powerpc"
e9b44189 572 vanilla_config="allyesconfig"
7e02032c
MJ
573 ubuntu_config="powerpc-config.flavour.powerpc-smp"
574 ;;
575
576 "ppc64el")
577 karch="powerpc"
e9b44189 578 vanilla_config="allyesconfig"
7e02032c
MJ
579 ubuntu_config="ppc64el-config.flavour.generic"
580 ;;
581
582 *)
583 echo "Unsupported arch $arch"
584 exit 1
585 ;;
586 esac
587else
04873cc3 588 echo "No arch or cross_arch specified"
7e02032c
MJ
589 exit 1
590fi
339db64d 591
339db64d 592
b214d997 593
5a196804
MJ
594# First get the kernel build from the object store, or build it, if it's
595# not available.
339db64d 596
5a196804
MJ
597echo "# Setup endpoint
598host_base = obj.internal.efficios.com
599host_bucket = obj.internal.efficios.com
600bucket_location = us-east-1
601use_https = True
7e02032c 602
5a196804
MJ
603# Setup access keys
604access_key = jenkins
605secret_key = echo123456
339db64d 606
5a196804
MJ
607# Enable S3 v4 signature APIs
608signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 609
c45b04df 610url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 611obj_name="linux.tar.bz2"
87445931
MJ
612
613if [ "x${cross_arch}" = "x" ]; then
614 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/native"
615else
616 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/${cross_arch}"
617fi
618
5a196804 619obj_url="$obj_url_prefix/$obj_name"
339db64d 620
5a196804
MJ
621set +e
622s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
623ret=$?
624set -e
339db64d 625
5a196804
MJ
626case "$ret" in
627 "0")
628 extract_archive_obj
629 ;;
a1ae361e 630
5a196804
MJ
631 "12")
632 echo "File not found"
339db64d 633
5a196804
MJ
634 # Build all the things and upload
635 # then finish the module build...
339db64d 636
5a196804
MJ
637 git_clone_linux_sources
638 git_export_linux_sources
339db64d 639
5a196804 640 select_compiler
a1ae361e 641
5a196804
MJ
642 ## PREPARE FULL LINUX SOURCE TREE
643 build_linux_kernel
d138fc44 644
5a196804
MJ
645 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
646 extract_distro_headers
339db64d 647
5a196804 648 tar_archive_obj
339db64d 649
5a196804 650 upload_archive_obj
339db64d 651
5a196804 652 ;;
339db64d 653
5a196804
MJ
654 *)
655 echo "Unknown error? Abort"
656 exit 1
657 ;;
658esac
339db64d 659
5a196804 660select_compiler
f3d8604b 661
7e02032c 662## BUILD modules
5a196804
MJ
663# Either we downloaded a pre-build kernel or we built it and uploaded
664# the archive for future builds.
665
666cd "$WORKSPACE"
f3d8604b 667
339db64d 668# Build modules against full kernel sources
5a196804 669build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 670
339db64d 671# Build modules against kernel headers
5a196804 672build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 673
5a196804
MJ
674# Make sure some modules were actually built
675tree "${MODULES_OUTPUT_KSRC_DIR}"
676if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
677 echo "No modules built!"
678 exit 1
679fi
680
5a196804
MJ
681tree "${MODULES_OUTPUT_KHDR_DIR}"
682if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
683 echo "No modules built!"
684 exit 1
685fi
b214d997 686
f3d8604b 687# EOF
This page took 0.059744 seconds and 4 git commands to generate.